
#pragma once

#include <windows.h>
#include <queue>

class CCommand
{
public:
	virtual ~CCommand()
	{
	}
	virtual void Execute() = 0;
};

class CMessage
{
public:
	virtual ~CMessage()
	{
	}
};

template <class Item>
class CInstance
{
private:
	CRITICAL_SECTION lock;
public:
	std::queue<Item> Items;
	
public:
	CInstance()
	{
		InitializeCriticalSection( &lock );
	}

	~CInstance()
	{
		DeleteCriticalSection( &lock );
	}

	void Lock()
	{
		EnterCriticalSection( &lock );
	}

	void UnLock()
	{
		LeaveCriticalSection( &lock );
	}
};

typedef CInstance<CCommand*> CCommandQueue;
typedef CInstance<CMessage*> CMessageQueue;
